Attribute VB_Name = "DDEClientXLS"
'*****************************************************************************************
'*************   modul DDEClientXLS ver 1.10    MICROPEL s.r.o.       ********************
'*****************************************************************************************
'30.11.2019 doplnena direktiva PtrSafe pro 64-bit systemy

'30.05.2013 oprava: ukazatel prubehu - progressbar neukazoval pohyb pri cteni/zapisu vice jak 1000 polozek
'
'22.04.2013 new:
'funkce ctenni/zapis tabulky je rozsirena o pristup do pameti automatu abs a user dle protokolu MEM.
'Syntaxe se rozsiruje v polozce typeMEM: doposud jsme znali stack,word,bit. Nyni je mozne pouzit pro pristup stranky pameti abs a user.
'Format zapisu je takovy, ze se slouci nazev stranky a typ promenne, napr. userword, userfloat, absint ap.
'
'           uprava: snizen pocet polozek v bloku z 21 na 15 kvuli typu float
'
'
'02.10.2012 uprava: odstranena vazba na modul VBAmodul.dll - progressbar resim dialogem v frmProgressBar.frm
'
'25.2.2009  uprava: prejmenovani modulu na DDEClientXLS (puvodni DDEClinetPES)
'
'24.2.2009  oprava: pokud byl pocet zpracovavanych hodnot maly, pretekl vypocet perStep * 100 ve volani Progressbar2
'
'15.1. 2007    new: fce CloseVBAModule2 ma parametr Bool, zap/vyp hlaseni chyby
'
'08.12.2006    new: pridana fce ProgressBar2 do komponenty VBAmodule.dll - aby se procenta mohla predavat v setinach
'
'22.11. 2006   new: fuknce ProcessDDE pro zpracovani pozadavku bez vazby na list, na bunku(y)
'
'oprava: neslo aplikovat cteni/ zapis na tabulku o rozmeru 1x1, spatne nastavene pocatecni hodnoty
'v mistech zmen je komentar "oprava1"
'


'maximalni poet dat jednoho vycitani
Const numMax = 15 ' maximalni velikost kvuli typu LONG, ten je nejdelsi
'Dim Dllcomp As Object
Dim ErrArr() As Variant
Dim errNum As Integer

'Private Declare PtrSafe Sub CoFreeUnusedLibraries Lib "OLE32" ()


Function GetDDEcommand(ByVal iswrite As Boolean, _
                                ByVal addrPLC As Integer, _
                                ByVal addrMem As Long, _
                                ByVal typeMem As String, _
                                ByVal index As Integer, _
                                ByVal numPaket As Integer) As String
                                
    'delka dat v tomto paketu
    lenPaket = index - numMax * numPaket
    
    '--------------sestaveni prikazu DDE----------------------
    If (Left(typeMem, 3) = "abs") Then
    'protokolem MEM
        typ = Mid(typeMem, 4)
        If typ = "byte" Then typelen = 1
        If typ = "word" Then typelen = 2
        If typ = "int" Then typelen = 2
        If typ = "longword" Then typelen = 4
        If typ = "longint" Then typelen = 4
        If typ = "float" Then typelen = 4
        
        If (iswrite) Then
            direction = "write"
            cnt = ""
        Else
            direction = "read"
            cnt = "count:" + CStr(lenPaket)
        End If
                
        pointerMEM = CStr(addrMem + (numPaket * numMax) * typelen)
        pointerPLC = CStr(addrPLC)
        GetDDEcommand = "mem;" + direction + ";abs;" + typ + ";" + pointerPLC + ";" + pointerMEM + ";" + cnt
    
    ElseIf (Left(typeMem, 4) = "user") Then
    'protokolem MEM
        typ = Mid(typeMem, 5)
        If typ = "byte" Then typelen = 1
        If typ = "word" Then typelen = 2
        If typ = "int" Then typelen = 2
        If typ = "longword" Then typelen = 4
        If typ = "longint" Then typelen = 4
        If typ = "float" Then typelen = 4
        
        If (iswrite) Then
            direction = "write"
            cnt = ""
        Else
            direction = "read"
            cnt = "count:" + CStr(lenPaket)
        End If
                
        pointerMEM = CStr(addrMem + (numPaket * numMax) * typelen)
        pointerPLC = CStr(addrPLC)
        GetDDEcommand = "mem;" + direction + ";user;" + typ + ";" + pointerPLC + ";" + pointerMEM + ";" + cnt
                    
    Else
    'po startu jako PESDDE
        
        If (iswrite) Then
            direction = "s"
        Else
            direction = "r"
        End If
        
        pointerADDR = "[" + CStr(addrMem + numPaket * numMax) + "]"
        pointerPLC = Left(typeMem, 1) + "[" + CStr(addrPLC) + "]"
        GetDDEcommand = direction + pointerPLC + pointerADDR + "[" + CStr(lenPaket) + "]"
                    
    End If
                                
End Function

'Popis parametru fce WriteTableToPLC a jejich hodnot

' direction - hodnoty LINE nebo COLUMN; tabulka bude vycitana po radcich nebo sloupcich
' startLine & startCol - ciselne definice leve horni bunky tabulky
' endLine & endCol - ciselne definice prave dolni bunky tabulky
' typeMem - textova promenna urcuje druh pameti, kam se data budou zapisovat, muze nabyvat
'           hodnot "stack"  , "bit", "word" word
' addrPLC - adresa atomatu v siti PESNET
' addrMem - adresa v pameti, kam se maji nahr8t data z tabulky
' perLen - (nepovinne) hodnota od 0 do 100, predstavujici takovou cast progresbaru
'          (grafickeho ukazatele), ktery ma tato funkce k dispozici

Function WriteTableToPLC(ByVal direction As String, _
                    ByVal startLine, _
                    ByVal startCol, _
                    ByVal endLine, _
                    ByVal endCol As Integer, _
                    ByVal typeMem As String, _
                    ByVal addrPLC As Integer, _
                    ByVal addrMem As Long, _
                    Optional ByVal perLen = 100) As Boolean
                    


'inicializace vystupni hodnoty
WriteTableToPLC = True

'umisteni tabulky, uprava parametru
Dim widthTable As Integer: widthTable = endCol - startCol + 1
Dim heightTable As Integer: heightTable = endLine - startLine + 1
Dim numTable As String: numTable = heightTable * widthTable

'inicializace DDE kanalu
channelNumber = Application.DDEInitiate( _
    App:="pesdde", _
    topic:="var")

'linearizace tabulky podle radku nebo sloupce
Dim outArray() As Variant
Dim index As Integer

index = 0
Select Case direction
    
    Case Is = "LINE"
        For i = startLine To endLine
        For j = startCol To endCol
            ReDim Preserve outArray(index + 1)
            outArray(index) = Cells(i, j).Value
            index = index + 1
        Next j
        Next i
    
    Case Is = "COLUMN"
        For j = startCol To endCol
        For i = startLine To endLine
            ReDim Preserve outArray(index + 1)
            outArray(index) = Cells(i, j).Value
            index = index + 1
        Next i
        Next j
    Case Else
        'vyhlasit chybu
        MsgBox ("Chybny parametr LINE/COLUMN" + Chr(13) + "obrate se na dodavatele")
        GoTo ENDofSub
End Select

'zapis dat z linearni tabulky dat do PESNET
Dim perstep As Double

numPaket = 0
perstep = perLen / (numTable / numMax)
If (perstep > 100) Then perstep = 100

For i = 1 To numTable
    strOut = strOut + CStr(outArray(i - 1)) + "#"
    If (i = numMax * (numPaket + 1) Or i = numTable) Then
    
            'zobrazeni progressbar
            ret = DoEvents
            'nutny PESDDE7.701 a vyssi
            'go = Dllcomp.DisplayProgBar2(perstep * 100, "Zpis do automatu " + CStr(addrPLC))
            go = frmProgressBar.DisplayProgBar3(perstep, "Zpis do automatu " + CStr(addrPLC))
            If go = False Then
                WriteTableToPLC = False
                GoTo ENDofSub
            End If
            
            cmdOut = GetDDEcommand(True, addrPLC, addrMem, typeMem, i, numPaket)
            
            'ddezapis
            'pointerADDR = "[" + CStr(addrMem + numPaket * numMax) + "]"
            'pointerPLC = Left(typeMem, 1) + "[" + CStr(addrPLC) + "]"
            'cmdOut = "s" + pointerPLC + pointerADDR + "##" + strOut + "#"
            
            cmdOut = cmdOut + "##" + strOut + "#"
            
            'POZOR! delka predavaneho retezce presahla velikost 255 znaku
            Debug.Assert Len(cmdOut) < 256
                                    
            returnList = Application.DDERequest(channelNumber, cmdOut)
            appErrorCode = Application.DDEAppReturnCode
            
            If IsError(returnList) Or appErrCode Then
                ReDim Preserve ErrArr(errNum + 1)
                ErrArr(errNum) = addrPLC
                errNum = errNum + 1
               GoTo ENDofSub
            End If
            strOut = ""
            numPaket = numPaket + 1
    End If
Next i
ENDofSub:
'konec kanalu DDE
Application.DDETerminate channelNumber

End Function

'Popis parametru fce ReadTableFromPLC a jejich hodnot

' direction - hodnoty LINE nebo COLUMN; tabulka bude zapisovana po radcich nebo sloupcich
' startLine & startCol - ciselne definice leve horni bunky tabulky
' endLine & endCol - ciselne definice prave dolni bunky tabulky
' typeMem - textova promenna urcuje druh pameti, odkud se data budou zapisovat, muze nabyvat
'           hodnot "stack"  , "bit", "word"
' addrPLC - adresa atomatu v siti PESNET
' addrMem - adresa v pameti, kam se maji nahr8t data z tabulky
' perLen - (nepovinne) hodnota od 0 do 100, predstavujici takovou cast progresbaru
'          (grafickeho ukazatele), ktery ma tato funkce k dispozici

Function ReadTableFromPLC(ByVal direction As String, _
                    ByVal startLine, _
                    ByVal startCol, _
                    ByVal endLine, _
                    ByVal endCol As Integer, _
                    ByVal typeMem As String, _
                    ByVal addrPLC As Integer, _
                    ByVal addrMem As Long, _
                    Optional ByVal perLen = 100) As Boolean



'inicializace vystupni hodnoty
ReadTableFromPLC = True
                   
Debug.Assert (endCol >= startCol)       'spatne vlozene rozmery vycitane tabulky: SLOUPEC
Debug.Assert (endLine >= startLine)     'spatne vlozene rozmery vycitane tabulky: RADEK

'umisteni tabulky
Dim widthTable As Integer: widthTable = endCol - startCol + 1
Dim heightTable As Integer: heightTable = endLine - startLine + 1
Dim numTable As String: numTable = heightTable * widthTable



'inicializace DDE kanalu
channelNumber = Application.DDEInitiate( _
    App:="pesdde", _
    topic:="var")

'linearni cteni
Dim startChar: startChar = 0 'oprava1 = Dim startChar: startChar = 1
Dim endChar: endChar = 0     'oprava1 = Dim endChar: endChar = 1
Dim pArray: pArray = 0
Dim myArray() As Variant
Dim perstep As Double

numPaket = 0
perstep = perLen / (numTable / numMax)
If (perstep > 100) Then perstep = 100

For i = 1 To numTable
    If (i = numMax * (numPaket + 1) Or i = numTable) Then
                        
            'zobrazeni progresbar
            ret = DoEvents
            'nutny PESDDE7.701 a vyssi
            'go = Dllcomp.DisplayProgBar2(perstep * 100, "ten z automatu " + CStr(addrPLC))
            go = frmProgressBar.DisplayProgBar3(perstep, "ten z automatu " + CStr(addrPLC))
            
            If go = False Then
                ReadTableFromPLC = False
                GoTo ENDofSub
            End If
            
            cmdOut = GetDDEcommand(False, addrPLC, addrMem, typeMem, i, numPaket)
            
            '--------------vykonani prikazu DDE----------------------
            returnList = Application.DDERequest(channelNumber, cmdOut)
            appErrorCode = Application.DDEAppReturnCode
            
            If IsError(returnList) Or appErrCode Then
                ReDim Preserve ErrArr(errNum + 1)
                ErrArr(errNum) = addrPLC
                errNum = errNum + 1
                GoTo ENDofSub
            End If

            For j = LBound(returnList) To UBound(returnList)
            strDDEOut = returnList(j)
            Next j
            numPaket = numPaket + 1
            
            'rozkousani retezce do linearniho pole
            startChar = 0   'oprava1
            endChar = 0     'oprava1
            For j = 1 To Len(strDDEOut)
            Char = Mid(strDDEOut, j, 1)
            If Char = "#" Then
    
                If endChar <= startChar Then
                    startChar = j
                Else
                    ReDim Preserve myArray(pArray + 1)
                    myArray(pArray) = Mid(strDDEOut, startChar + 1, endChar - startChar)
                    If (pArray = 62) Then
                        pArray = 62
                    End If
                    pArray = pArray + 1
                    endChar = j
                    startChar = j
                End If
         
            Else: endChar = j
            End If
        
            Next j
            
            'nove...
            'na zaver zkontrolovat jestli nezustala mezi start a end hodnota
            If endChar > startChar Then
                ReDim Preserve myArray(pArray + 1)
                myArray(pArray) = Mid(strDDEOut, startChar + 1, endChar - startChar)
                pArray = pArray + 1
            End If
            
    End If
Next i

'prepsani linearniho pole myArray do tabulky Excelu

index = 0

Select Case direction
    
    Case Is = "LINE"
        For i = startLine To endLine
        For j = startCol To endCol
            'Cells(i, j) = CLng(myArray(index))
            temp = myArray(index)
            Cells(i, j).Value = temp
             index = index + 1
        Next j
        Next i
    
    Case Is = "COLUMN"
        For j = startCol To endCol
        For i = startLine To endLine
            'Cells(i, j) = CLng(myArray(index))
            Cells(i, j).Value = myArray(index)
            index = index + 1
        Next i
        Next j
    Case Else
        'vyhlasit chybu
        MsgBox ("chybny parametr LINE/COLUMN")
        GoTo ENDofSub
End Select

ENDofSub:

'konec kanalu DDE
Application.DDETerminate channelNumber

End Function

Sub CloseVBAmodul()
'odpojeni knihovny VBAmodul

    'Call Dllcomp.CloseProgBar
    'Set Dllcomp = Nothing
    'Call CoFreeUnusedLibraries
    frmProgressBar.CloseProgBar
    
'vypis chyb komunikace
    If errNum > 0 Then
        Dim msg, Style, Title
        msg = "Dolo k chybe pri komunikaci s automaty:" + Chr(13)
        For i = 0 To errNum - 1
        msg = msg + " adresa: " + CStr(ErrArr(i)) + Chr(13)
        Next i
        Style = vbYes + vbCritical + vbDefaultButton1
        Title = "Vpis chyb komunikace"
        MsgBox msg, Style, Title
    End If
    
End Sub
Sub CloseVBAmodul2(msg As Boolean)
'odpojeni knihovny VBAmodul

    'Call Dllcomp.CloseProgBar
    'Set Dllcomp = Nothing
    'Call CoFreeUnusedLibraries
    frmProgressBar.CloseProgBar
    
'vypis chyb komunikace
    If errNum > 0 Then
        If msg Then
            Dim msg, Style, Title
            msg = "Dolo k chybe pri komunikaci s automaty:" + Chr(13)
            For i = 0 To errNum - 1
            msg = msg + " adresa: " + CStr(ErrArr(i)) + Chr(13)
            Next i
            Style = vbYes + vbCritical + vbDefaultButton1
            Title = "Vpis chyb komunikace"
            MsgBox msg, Style, Title
        End If
    End If
End Sub


Sub InitVBAmodul()
    'pripojeni knihovny a inicializace globalnich promennych
    
    'POZOR: v pripade chyby v pri vytvareni tohoto objektu zkontrolujte pritomnost
    'a registraci knihovny VBAmodul.dll
    
    'Set Dllcomp = CreateObject("VBAmodul.UserInterface")
    ReDim ErrArr(0)
    errNum = 0
End Sub

'******************************************************************************************************
'slouzi k primemu zpracovani prikazu pro PesDDE, DataSERVER bez vazby na bunku v listu
'
'priklad pouziti: nastaveni bitu RESET na hodnotu 1
'
'Public Sub Reset_PLC()
'    result = ProcessDDE("sb[9][318]1")     'pozn.: RESET je index 318
'    If result = "OK" Then MsgBox "Program resetovn"
'    If result = "ERROR" Then MsgBox "Chyba operace!"
'End Sub
'
'
Function ProcessDDE(ByVal itemToDDE As String) As String

'inicializace DDE kanalu
channelNumber = Application.DDEInitiate( _
    App:="pesdde", _
    topic:="var")

returnList = Application.DDERequest(channelNumber, itemToDDE)
appErrorCode = Application.DDEAppReturnCode
        
If IsError(returnList) Or appErrCode Then
    ProcessDDE = "ERROR"
    GoTo ENDofSub
Else
    For j = LBound(returnList) To UBound(returnList)
        ProcessDDE = returnList(j)
    Next j
End If
            
ENDofSub:

'konec kanalu DDE
Application.DDETerminate channelNumber

End Function




    



